using Syntriax.Engine.Core;

namespace Syntriax.Engine.Physics2D;

public class Collider2DCircle : Collider2DBase, ICircleCollider2D
{
    private Circle _circleLocal = Circle.UnitCircle;

    public Circle CircleWorld { get; protected set; } = Circle.UnitCircle;
    public Circle CircleLocal
    {
        get => _circleLocal;
        set
        {
            _circleLocal = value;
            NeedsRecalculation = true;
        }
    }

    public override void CalculateCollider() => CircleWorld = Transform.Transform(_circleLocal);

    public Collider2DCircle() { }
    public Collider2DCircle(Circle circle) => CircleLocal = circle;
}
